#include <iostream>
#include <vector>
#include <cstdlib>

using namespace std;

/*
 * Implement choose_new_target and choose_train
 *
 * You have the following variables at your disposal:
 * num_players: number of bots
 * num_skills: number of skills
 * target: the current target
 * skill_difficulty: the difficulties of the skills
 * days_remaining: list for each player of this players skills. For each player there is a list of missing training per skill
 *    (i.e. it is the other way than in the description. It starts at s_i and ends at 0 once mastered)
 * player_selection: the last action for each player (i.e. which skill was chosen)
 * total_score: scores for each player total over all games
 * score: scores for each player of the current game
 * skill_unmastered: which skills have not yet a winner
 */

int num_players, num_skills, target;
vector<int> skill_difficulty, player_selection;
vector<double> total_score, score;
vector<bool> skill_unmastered;
vector<vector<int>> days_remaining;

int choose(vector<int>& v){
    return v[rand()%v.size()];
}

int choose_new_target(){
    vector<int> pos;
    for(int i = 0; i < num_skills; i++){
        if(skill_unmastered[i]){
            pos.push_back(i);
        }
    }
    return choose(pos);
}

int choose_train(){
    vector<int> pos;
    for(int i = 0; i < num_skills; i++){
        if (days_remaining[0][i] > 1 || (days_remaining[0][i] == 1 && target == i)){
            pos.push_back(i);
        }
    }
    return choose(pos);
}

int main() {
    srand(42);
    while(true){
        cin >> num_players >> num_skills;
        skill_difficulty.resize(num_skills);
        skill_unmastered.assign(num_skills, true);
        for(int i = 0; i < num_skills; i++) {
            cin >> skill_difficulty[i];
        }
        days_remaining.assign(num_players, skill_difficulty);
        score.assign(num_players, 0);
        player_selection.resize(num_players);
        if(total_score.size() != num_players) {
        	total_score.assign(num_players, 0);
        }

        while(true){
            cin >> target;
            if (target == -3){
                return 0;
            }
            vector<int> winners;
            for(int i = 0; i < num_players; i++){
                cin >> player_selection[i];
                if (player_selection[i] >= 0){
                    days_remaining[i][player_selection[i]] -= 1;
                    if (days_remaining[i][player_selection[i]] == 0){
                        winners.push_back(i);
                        skill_unmastered[player_selection[i]] = false;
                    }
                }
            }
            for(int winner : winners){
                score[winner] += 1.0/winners.size();
                total_score[winner] += 1.0/winners.size();
            }

            if (target == -1){
                target = choose_new_target();
                cout << target << endl;
            } else if (target == -2){
                break;
            }

            cout << choose_train() << endl;
        }
    }

    return 0;
}
