const range = n => [...Array(n).keys()]

/*
 * Implement chooseNewTarget and chooseTrain
 *
 * You have the following variables at your disposal:
 * numPlayers: number of bots
 * numSkills: number of skills
 * target: the current target
 * skillDifficulty: the difficulties of the skills
 * daysRemaining: list for each player of this players skills. For each player there is a list of missing training per skill
 *    (i.e. it is the other way than in the description. It starts at s_i and ends at 0 once mastered)
 * playerSelection: the last action for each player (i.e. which skill was chosen)
 * totalScore: scores for each player total over all games
 * score: scores for each player of the current game
 * skillUnmastered: which skills have not yet a winner
 */

let numPlayers, numSkills, target
let skillDifficulty, playerSelection
let totalScore, score
let skillUnmastered
let daysRemaining

function choose (v) {
  return v[Math.floor(Math.random() * v.length)]
}

function chooseNewTarget () {
  let pos = range(numSkills).filter(i => skillUnmastered[i])
  return choose(pos)
}

function chooseTrain () {
  let pos = range(numSkills).filter(i =>
      daysRemaining[0][i] > 1 ||
      (daysRemaining[0][i] === 1 && target === i))
  return choose(pos)
}

function * main () {
  while (true) {
    [numPlayers, numSkills] = (yield).split(' ').map(Number)
    skillDifficulty = (yield).split(' ').map(Number)
    skillUnmastered = Array(numSkills).fill(true)
    daysRemaining = Array(numPlayers).fill().map(() => skillDifficulty.slice())
    score = Array(numPlayers).fill(0)
    if (!totalScore) {
      totalScore = Array(numPlayers).fill(0)
    }

    while (true) {
      target = +(yield)
      if (target === -3) {
        return
      }
      const winners = []
      playerSelection = (yield).split(' ').map(Number)
      for (let i = 0; i < numPlayers; i++) {
        if (playerSelection[i] >= 0) {
          daysRemaining[i][playerSelection[i]] -= 1
          if (daysRemaining[i][playerSelection[i]] === 0) {
            winners.push(i)
            skillUnmastered[playerSelection[i]] = false
          }
        }
      }
      for (let winner of winners) {
        score[winner] += 1 / winners.length
        totalScore[winner] += 1 / winners.length
      }

      if (target === -1) {
        target = chooseNewTarget()
        console.log(target)
      } else if (target === -2) {
        break
      }

      console.log(chooseTrain())
    }
  }
}

const readline = require('readline').createInterface({input: process.stdin})
const generator = main()
generator.next()
readline.on('line', line => generator.next(line))
