import random

# Implement choose_new_target and choose_train
#
# You have the following variables at your disposal:
# num_players: number of bots
# num_skills: number of skills
# target: the current target
# skill_difficulty: the difficulties of the skills
# days_remaining: list for each player of this players skills. For each player there is a list of missing training per skill
#    (i.e. it is the other way than in the description. It starts at s_i and ends at 0 once mastered)
# player_selection: the last action for each player (i.e. which skill was chosen)
# total_score: scores for each player total over all games
# score: scores for each player of the current game
# skill_unmastered: which skills have not yet a winner


def choose_new_target():
    return random.choice([x for x in range(num_skills) if skill_unmastered[x]])


def choose_train():
    possibilities = [x for x in range(num_skills) if days_remaining[0][x] > 1 or (days_remaining[0][x] == 1 and target == x)]
    return random.choice(possibilities)


def main():
    global num_players, num_skills, target, skill_difficulty, days_remaining, player_selection, total_score, score, skill_unmastered

    total_score = None
    while True:
        num_players, num_skills = map(int, input().split())
        skill_difficulty = list(map(int, input().split()))
        days_remaining = [skill_difficulty[:] for _ in range(num_players)]
        score = [0.0] * num_players
        skill_unmastered = [True] * num_skills
        if not total_score:
            total_score = [0.0] * num_players

        while True:
            target = int(input())
            if target == -3:
                return

            player_selection = map(int, input().split())
            winners = set()
            for i, o in filter(lambda x: x[1] >= 0, enumerate(player_selection)):
                days_remaining[i][o] -= 1
                if days_remaining[i][o] == 0:
                    winners.add(i)
                    skill_unmastered[o] = False
            for winner in winners:
                score[winner] += 1.0/len(winners)
                total_score[winner] += 1.0/len(winners)

            if target == -1:
                target = choose_new_target()
                print(target)
            elif target == -2:
                break

            print(choose_train())


if __name__ == "__main__":
    main()
