# Usage

The samurai.jar can be used to simulate games and tournaments. To run it you need Java (version 7 or higher). You can start it with `java -jar samurai.jar`. It supports several arguments and config files.

# Quick Start

Open the `players.txt` file and add your bot (you may need to change the number of players at the top of the file). Then run samurai.jar. The log of the game will be in `log/game.txt`. Open the visualization (`visualization/visualization.html`), copy the content of the log file into the textbox and press load. If you want to change the skill levels you can do that in the file `samurai.txt`. Note that the first value in this line is the number of skills, so you have to change this if you add/remove skills.

# Arguments

The server accepts the following arguments:

 - `-config file`: Loads the given config file.
 - `-players file`: Loads the given players file.
 - `-log config`: The configuration file for the logger.
 - `-tournament file`: Plays the given tournament file.

# Configuration File

If no configuration file is specified using an argument, the file `samurai.txt` is loaded. The file contains one item per line, first the key and after a space the value.

In the configuration file the following keys are accepted:

 - `log`: Configuration file for the logger.
 - `players`: Configuration file for players.
 - `skills`: The skills for the game. The value should be a space separated list of integers. The first integer is the number of skills. Then the values for the skills follow.
 - `timelimit`: Time limit for bots (like chess clock).
 - `gamecount`: Number of games per evaluation.
 - `tournament`: 0/1, whether tournament should be played.
 - `tournamentfile`: Config file of tournament.
 - `tournament_gamecount_multiplier`: Influences, how many games are played in a tournament (integer > 1).
 - `stderr_lines`: How many lines a bot may print to stderr.
 - `seed`: Seed used for all random generators in the server.

# Players File

If no configuration file is specified, the file `players.txt` is loaded. This file contains all commands used to run the players. The file starts with one integer, the number of players. For each player two lines follow: on the first line the name of the player, on the second line the command to start the player. This command is for example: `python bot.py` or `./bot`. If you want to use a network player (this bot runs on our servers), use `samurai://soi.ch:9929/botname` where botname is the name of the bot you want to use. You can omit the name and select a bot at runtime.

# Log Config

If no configuration file is specified, the file `logconfig.txt` is loaded. In the config file for each log channel three flags (0 or 1) and one string can be specified: whether to print the channel on stdout, stderr or file. If file is true, the channel will be written to the file specified by the string. If it is false, the string is ignored, but it can't be empty. Several outputs can be enabled at the same time. The first line of the file contains one String, the folder in which to save the logs.

The following channels are available, in the order as in the config file:

 - `Debug`: Debug messages of the server.
 - `Game`: Log file of the game, used for replay
 - `Behaviour`: Behaviour of a bot (e.g. bot crashed)
 - `External Debug`: The communication between the server and the external bots.
 - `Process Err`: Things an external bot writes to its stderr.
 - `Tournament`: Results of a tournament.

# Tournament File

A tournament file contains information about a tournament. The first line contains two integers `n m`, the number of games and the number of players. For each game two lines follow: on the first line the number of players in this game, followed by the name of the game; on the second line are the skills defined, using the same format as in the normal config (number of skills, followed by the skills). After the game specification the player specification follows in the same format as in the players file.

# Visualization

To start the visualization open `visualization/visualization.html` in your browser. To load a game, copy the log from the generated `game.txt` file into the textbox and click load. You can scroll through the game with the buttons `prev` and `next` or press `play` and let it play automatically. There are several diagrams, from top to bottom:
 - Score of the players over time.
 - For each player the current skill levels. The red framed pillar is the current target. The player with the yellow background chose the current target. If a pillar has a black background, this skill was already mastered.
 - For each skill the player levels over time. The skill with the yellow background is the current target. Skills with dark backgrounds were already mastered. The horizontal line shows the difficulty of this skill.
 